"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var axios_1 = require("axios");
var Tm4jApi = /** @class */ (function () {
    function Tm4jApi(baseUrl, authToken) {
        this.baseUrl = baseUrl;
        this.authToken = authToken;
    }
    Tm4jApi.prototype.getTestCyclesByProjectKey = function (projectKey, startAt, maxResults) {
        if (startAt === void 0) { startAt = 0; }
        if (maxResults === void 0) { maxResults = 50; }
        return axios_1.default({
            method: "GET",
            url: this.baseUrl + "/testcycles",
            headers: {
                'Authorization': "Bearer " + this.authToken
            },
            params: {
                'projectKey': projectKey,
                'startAt': startAt,
                'maxResults': maxResults
            }
        });
    };
    Tm4jApi.prototype.createTestCycle = function (projectKey, name) {
        return axios_1.default({
            method: "POST",
            url: this.baseUrl + "/testcycles",
            headers: {
                'Authorization': "Bearer " + this.authToken,
                'Content-Type': 'application/json'
            },
            data: JSON.stringify({
                'projectKey': projectKey,
                'name': name
            })
        });
    };
    Tm4jApi.prototype.getTestCasesByProjectKey = function (projectKey, startAt, maxResults) {
        if (startAt === void 0) { startAt = 0; }
        if (maxResults === void 0) { maxResults = 50; }
        return axios_1.default({
            method: "GET",
            url: this.baseUrl + "/testcases",
            headers: {
                'Authorization': "Bearer " + this.authToken
            },
            params: {
                'projectKey': projectKey,
                'startAt': startAt,
                'maxResults': maxResults
            }
        });
    };
    Tm4jApi.prototype.createTestCase = function (projectKey, name, folderId) {
        return axios_1.default({
            method: "POST",
            url: this.baseUrl + "/testcases",
            headers: {
                'Authorization': "Bearer " + this.authToken,
                'Content-Type': 'application/json'
            },
            data: JSON.stringify({
                'projectKey': projectKey,
                'name': name,
                'folderId': folderId
            })
        });
    };
    Tm4jApi.prototype.publishTestExecution = function (testExecution) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, axios_1.default({
                        method: "POST",
                        url: this.baseUrl + "/testexecutions",
                        headers: {
                            'Authorization': "Bearer " + this.authToken,
                            'Content-Type': 'application/json'
                        },
                        data: JSON.stringify(testExecution)
                    }).catch(function (e) {
                        var data = e.response.data;
                        console.error("Error occurred while posting execution results:");
                        console.error(data.errorCode + " " + data.status + ": " + data.message);
                    })];
            });
        });
    };
    return Tm4jApi;
}());
exports.Tm4jApi = Tm4jApi;
var TestCycle = /** @class */ (function () {
    function TestCycle(key, title) {
        this.key = key;
        this.name = title;
    }
    return TestCycle;
}());
exports.TestCycle = TestCycle;
var TestCase = /** @class */ (function () {
    function TestCase(key, title) {
        this.key = key;
        this.name = title;
    }
    return TestCase;
}());
exports.TestCase = TestCase;
var TestExecution = /** @class */ (function () {
    function TestExecution() {
    }
    return TestExecution;
}());
exports.TestExecution = TestExecution;
//# sourceMappingURL=tm4j-api.js.map