"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var tm4j_api_1 = require("./tm4j-api");
var cypress_cli_utils_1 = require("./cypress-cli-utils");
var parsers_1 = require("./parsers");
require("cypress");
var Tm4jUtils = /** @class */ (function () {
    function Tm4jUtils(options) {
        this.cypressToTm4jStatusMap = new Map([
            ["passed", "Pass"],
            ["failed", "Fail"],
            ["skipped", "Not Executed"]
        ]);
        this.tm4j = new tm4j_api_1.Tm4jApi(options.baseUrl, options.authToken);
        this.options = options;
        this.projectKey = options.projectKey;
        this.isDebug = options.debugOutput;
        this.apiMaxResults = options.apiMaxResults
            ? options.apiMaxResults
            : 100;
    }
    Tm4jUtils.prototype.publishReporterResults = function (testRun) {
        return __awaiter(this, void 0, void 0, function () {
            var testCycle, testExecutions;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.prepareTestCycle(testRun)];
                    case 1:
                        testCycle = _a.sent();
                        return [4 /*yield*/, this.prepareTestExecutions(testRun)];
                    case 2:
                        testExecutions = _a.sent();
                        return [4 /*yield*/, this.publishExecutionResults(testExecutions)];
                    case 3:
                        _a.sent();
                        return [2 /*return*/, testRun];
                }
            });
        });
    };
    Tm4jUtils.prototype.publishCypressCliResults = function (cypressRunResult) {
        return __awaiter(this, void 0, void 0, function () {
            var testRuns, _i, _a, testRun, _b, _c;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        testRuns = [];
                        _i = 0, _a = cypress_cli_utils_1.CypressCliUtils.convertCypressRunResult(cypressRunResult, this.options);
                        _d.label = 1;
                    case 1:
                        if (!(_i < _a.length)) return [3 /*break*/, 4];
                        testRun = _a[_i];
                        _c = (_b = testRuns).push;
                        return [4 /*yield*/, this.publishReporterResults(testRun).then(function (testRun) { return testRun; })];
                    case 2:
                        _c.apply(_b, [_d.sent()]);
                        _d.label = 3;
                    case 3:
                        _i++;
                        return [3 /*break*/, 1];
                    case 4: return [2 /*return*/, testRuns];
                }
            });
        });
    };
    Tm4jUtils.prototype.prepareTestCycle = function (testRun) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, key, name, projectTestCycles, existingTestCycle, _b;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        _a = parsers_1.Parsers.titleToKeyAndName(testRun.name), key = _a.key, name = _a.name;
                        testRun.key = key;
                        testRun.name = name;
                        if (!!testRun.key) return [3 /*break*/, 4];
                        return [4 /*yield*/, this.tm4j.getTestCyclesByProjectKey(this.options.projectKey).then(function (response) { return response.data.values; })];
                    case 1:
                        projectTestCycles = _c.sent();
                        existingTestCycle = projectTestCycles.find(function (tc) { return tc.name === testRun.name; });
                        if (!existingTestCycle) return [3 /*break*/, 2];
                        testRun.key = existingTestCycle.key;
                        return [3 /*break*/, 4];
                    case 2:
                        _b = testRun;
                        return [4 /*yield*/, this.tm4j.createTestCycle(this.options.projectKey, testRun.name).then(function (response) { return response.data.key; })];
                    case 3:
                        _b.key =
                            _c.sent();
                        _c.label = 4;
                    case 4: return [2 /*return*/, new tm4j_api_1.TestCycle(testRun.key, testRun.name)];
                }
            });
        });
    };
    Tm4jUtils.prototype.prepareTestExecutions = function (testRun) {
        return __awaiter(this, void 0, void 0, function () {
            var testCases_1, _i, _a, result, _b;
            var _this = this;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        testRun.results.forEach(function (r) {
                            var _a = parsers_1.Parsers.titleToKeyAndName(r.name), key = _a.key, name = _a.name;
                            r.key = key;
                            r.name = name;
                        });
                        if (!testRun.results.find(function (r) { return !r.key; })) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.tm4j.getTestCasesByProjectKey(this.options.projectKey, 0, this.apiMaxResults)
                                .then(function (response) { return response.data.values; })];
                    case 1:
                        testCases_1 = _c.sent();
                        testRun.results.filter(function (r) { return !r.key; }).forEach(function (r) {
                            if (_this.isDebug) {
                                console.log("Looking for test case key for: " + r.name);
                            }
                            var testCase = testCases_1.find(function (tc) { return tc.name === r.name; });
                            if (testCase) {
                                r.key = testCase.key;
                            }
                            if (_this.isDebug) {
                                if (r.key) {
                                    console.log("Key found: " + r.key);
                                }
                                else {
                                    console.log('Key was not found');
                                }
                            }
                        });
                        _c.label = 2;
                    case 2:
                        if (this.isDebug) {
                            console.log("Test Results:");
                            console.log(testRun);
                        }
                        _i = 0, _a = testRun.results.filter(function (r) { return !r.key; });
                        _c.label = 3;
                    case 3:
                        if (!(_i < _a.length)) return [3 /*break*/, 6];
                        result = _a[_i];
                        _b = result;
                        return [4 /*yield*/, this.tm4j.createTestCase(this.options.projectKey, result.name, this.options.defaultTestCaseFolderId)
                                .then(function (response) { return response.data.key; })];
                    case 4:
                        _b.key = _c.sent();
                        _c.label = 5;
                    case 5:
                        _i++;
                        return [3 /*break*/, 3];
                    case 6: return [2 /*return*/, testRun.results.map(function (r) {
                            var execution = new tm4j_api_1.TestExecution();
                            execution.projectKey = _this.options.projectKey;
                            execution.testCycleKey = testRun.key;
                            execution.testCaseKey = r.key;
                            execution.statusName = _this.cypressToTm4jStatusMap.get(r.status);
                            execution.executionTime = r.duration;
                            execution.comment = _this.formatComment(r.comment);
                            execution.environmentName = r.environment;
                            return execution;
                        })];
                }
            });
        });
    };
    Tm4jUtils.prototype.formatComment = function (comment) {
        if (comment) {
            return comment.replace(/(?:\r\n|\r|\n)/g, '<br>');
        }
        else {
            return comment;
        }
    };
    // private async getAllTestCasesByProjectKey() {
    //     let testCases: TestCase[] = []
    //     let startAt: number = 0;
    //     let isLast: boolean = false
    //     do {
    //         await this.tm4j.getTestCasesByProjectKey(this.projectKey, startAt, this.apiMaxResults).then(response => {
    //             testCases.push(response.data.values)
    //             isLast = response.data.isLast
    //         })
    //         startAt += this.apiMaxResults
    //     } while (isLast === false)
    //
    //     return testCases
    // }
    Tm4jUtils.prototype.publishExecutionResults = function (testExecutions) {
        return __awaiter(this, void 0, void 0, function () {
            var _i, testExecutions_1, e;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _i = 0, testExecutions_1 = testExecutions;
                        _a.label = 1;
                    case 1:
                        if (!(_i < testExecutions_1.length)) return [3 /*break*/, 4];
                        e = testExecutions_1[_i];
                        return [4 /*yield*/, this.tm4j.publishTestExecution(e)];
                    case 2:
                        _a.sent();
                        _a.label = 3;
                    case 3:
                        _i++;
                        return [3 /*break*/, 1];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    return Tm4jUtils;
}());
exports.Tm4jUtils = Tm4jUtils;
//# sourceMappingURL=tm4j-utils.js.map